clear all;
clc;

gasshortage = xlsread('GasShortageProfile.xlsx');
etbws       = xlsread('ETvsBWS.xlsx','x-y');
effecttotal = xlsread('IOeffects.xlsx','IO');
deltatdbu   = xlsread('deltatdbu.xlsx');
deltatdbu   = deltatdbu(1:16,1);
sector      = xlsread('IOeffects.xlsx','Sector');
shares      = xlsread('gasshare.xlsx','gas');
mining      = xlsread('mining.xlsx','Mining');
bu1         = effecttotal(1:17,2);
bu2         = effecttotal(1:17,5);
bu          = [bu1,bu2];
td1         = effecttotal(1:17,10);
td2         = effecttotal(1:17,13);
td          = [td1,td2];
min11       = mining(1:17,2);
min12       = mining(1:17,3);
min1        = [min11,min12];
min21       = mining(1:17,7);
min22       = mining(1:17,8);
min2        = [min21,min22];
sector      = sector(1:11,1);
gasshortage = gasshortage(61:84,7);
gasshortper = (gasshortage/250)*100;
monthslab   = {''; ''; '2023-03'; ''; ''; '2023-06'; ''; ''; '2023-09'; ''; ''; '2023-12';''; ''; '2024-03'; ''; ''; '2024-06'; ''; ''; '2024-09'; ''; ''; '2024-12'};
statesbu    = {'RP'; 'BW'; 'SL'; 'ST'; 'TH'; 'BY'; 'NI'; 'SN'; 'NW'; 'HE'; 'BB'; 'SH'; 'HB'; 'MV'; 'BE'; 'HH'; 'DE'};
statestd    = {'BW'; 'RP'; 'ST'; 'TH'; 'BY'; 'SL'; 'NI'; 'SN'; 'NW'; 'BB'; 'HE'; 'HB'; 'SH'; 'MV'; 'BE'; 'HH'; 'DE'};
statesdelta = {'SL'; 'RP'; 'ST'; 'HE'; 'BY'; 'BB'; 'BW'; 'TH'; 'SH'; 'BE'; 'NI'; 'SN'; 'MV'; 'NW'; 'HH'; 'HB'};
statesshare = {'BW'; 'RP'; 'TH'; 'SL'; 'NW'; 'BY'; 'ST'; 'SN'; 'HE'; 'NI'; 'SH'; 'BB'; 'HB'; 'MV'; 'BE'; 'HH'};
statesmin1  = {'RP'; 'BW'; 'NI'; 'BY'; 'ST'; 'SH'; 'HE'; 'TH'; 'NW'; 'SN'; 'HH'; 'BE'; 'BB'; 'HB'; 'SL'; 'MV'; 'DE'};
statesmin2  = {'RP'; 'BW'; 'ST'; 'NI'; 'TH'; 'BY'; 'SH'; 'SN'; 'HE'; 'SL'; 'BB'; 'NW'; 'BE'; 'MV'; 'HH'; 'HB'; 'DE'};

secnames    = {'Metals';'Mining';'Car Industry';'Textiles, Leather';'Machin., Electrc. Equipm.';'Chemic., Pharmac.';'Petroleum, Coke';'Wood, Paper, Print';'Oth. Manufac.';'Non-metallic Minerals';'Food, Bev., Tob.'};

%secnames    = {'Car Industry';'Oth. Manufac.';'Food, Bev., Tob.';'Metals';'Chemic., Pharmac.';'Machin., Electrc. Equipm.';'Wood, Paper, Print';'Mining';'Textiles, Leather';'Petroleum, Coke';'Non-metallic Minerals'};
buffer      = ones(1,24)*10;

dates       = 2023.00:(1/12):2024.92;

fig   = figure;
    hold on
    box on
        plot(gasshortper,'-k','LineWidth',2)
        plot(buffer,'--k','LineWidth',2)
        ylabel('% of total gas store','interpreter','latex','color','k','FontSize',16)
        xlabel('Month','interpreter','latex','color','k','FontSize',16)
        ylim([0 100])
        xticks([1:1:24])
        xticklabels(monthslab)
        set(gca,'ycolor','k')
        set(gca,'TickLabelInterpreter','latex','FontSize',16)
    hold off
    orient landscape;
    print(fig, 'storageprofile', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
    hold on
    box on
        scatter(etbws(:,1),etbws(:,2),'filled','MarkerEdgeColor','k','MarkerFaceColor',[0.75 0.75 0.75])
        ylabel('% share in employment','interpreter','latex','color','k','FontSize',16)
        xlabel('% share in value added','interpreter','latex','color','k','FontSize',16)
        ylim([0 35])
        xlim([0 35])
        set(gca,'ycolor','k')
        set(gca,'TickLabelInterpreter','latex','FontSize',16)
    hold off
    orient landscape;
    print(fig, 'etbwstotal', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
    hold on
    box on
        scatter(etbws(1:16,5),etbws(1:16,6),'filled','MarkerEdgeColor','k','MarkerFaceColor',[0.75 0.75 0.75])
        ylabel('% share in employment','interpreter','latex','color','k','FontSize',16)
        xlabel('% share in value added','interpreter','latex','color','k','FontSize',16)
        ylim([0 35])
        xlim([0 35])
        set(gca,'ycolor','k')
        set(gca,'TickLabelInterpreter','latex','FontSize',16)
    hold off
    orient landscape;
    print(fig, 'etbwsmanu', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
tiledlayout(2,1);
    nexttile
        hold on
        box on
        b = bar(td)
        title('Top-down','interpreter','latex','FontSize',16)
        ylim([-3 0])
        ylabel('%','interpreter','latex','FontSize',16)
        yticks([-3.00:1.00:0.00])
        xticks(1:1:17)
        xticklabels(statestd)
        b(1).FaceColor = [0.35 0.35 0.35]
        b(2).FaceColor = [0.85 0.85 0.85]
        hold off
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    nexttile
        hold on
        box on
        b = bar(bu)
        title('Bottom-up','interpreter','latex','FontSize',16)
        ylim([-3 0])
        ylabel('%','interpreter','latex','FontSize',16)
        yticks([-3.00:1.00:0.00])
        xticks(1:1:17)
        xticklabels(statesbu)
        xlabel('German states','interpreter','latex','FontSize',16)
        b(1).FaceColor = [0.35 0.35 0.35]
        b(2).FaceColor = [0.85 0.85 0.85]
        legend('1st round','2nd round','Location','southeast','interpreter','latex','FontSize',16)
        legend('boxoff')
        hold off
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    orient landscape;
    print(fig, 'tdbucompare', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
    box on
    b = bar(sector)
    %title('Top-down','interpreter','latex','FontSize',16)
    ylim([-12 27])
    ylabel('Index','interpreter','latex','FontSize',16)
    yticks([-12.00:3.00:27.00])
    xticks(1:1:11)
    xticklabels(secnames)
    xtickangle(45)
    xlabel('Sectors','interpreter','latex','FontSize',16)
    b(1).FaceColor = [0.85 0.85 0.85]
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    orient landscape;
    print(fig, 'importindex', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
    box on
    b = bar(deltatdbu)
    %title('Top-down','interpreter','latex','FontSize',16)
    %ylim([-15 6])
    ylabel('percentage points','interpreter','latex','FontSize',16)
    %yticks([-15.00:3.00:6.00])
    xticks(1:1:17)
    xticklabels(statesdelta)
    xlabel('German states','interpreter','latex','FontSize',16)
    b(1).FaceColor = [0.85 0.85 0.85]
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    orient landscape;
    print(fig, 'deltatdbu', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
    hold on
    box on
        b = bar(shares,'stacked')
        b(1).FaceColor = [0.50 0.50 0.50]
        b(2).FaceColor = [0.80 0.80 0.80]
        ylim([0 35])
        yticks([0.00:5.00:35.00])
        xticks(1:1:17)
        xticklabels(statesshare)
        ylabel('%','interpreter','latex','FontSize',16)
        xlabel('German states','interpreter','latex','FontSize',16)        
        legend('Gas-intensive manufacturing','Remaining manufacturing','interpreter','latex','FontSize',16,'Location','northeast');
        legend('boxoff')
    hold off
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    orient landscape;
    print(fig, 'gasshares', '-dpdf','-bestfit');
close(gcf);

fig   = figure;
tiledlayout(2,1);
    nexttile
        hold on
        box on
        b = bar(min1)
        title('First-round','interpreter','latex','FontSize',16)
        ylim([-3 0])
        ylabel('%','interpreter','latex','FontSize',16)
        yticks([-3.00:1.00:0.00])
        xticks(1:1:17)
        xticklabels(statesmin1)
        b(1).FaceColor = [0.35 0.35 0.35]
        b(2).FaceColor = [0.85 0.85 0.85]
        hold off
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    nexttile
        hold on
        box on
        b = bar(min2)
        title('Second-round','interpreter','latex','FontSize',16)
        ylim([-3 0])
        ylabel('%','interpreter','latex','FontSize',16)
        yticks([-3.00:1.00:0.00])
        xticks(1:1:17)
        xticklabels(statesmin2)
        xlabel('German states','interpreter','latex','FontSize',16)
        b(1).FaceColor = [0.35 0.35 0.35]
        b(2).FaceColor = [0.85 0.85 0.85]
        legend('Scaled-down','Baseline','Location','southeast','interpreter','latex','FontSize',16)
        legend('boxoff')
        hold off
    set(gca,'ycolor','k') 
    set(gca,'TickLabelInterpreter','latex','FontSize',16)
    orient landscape;
    print(fig, 'scaled', '-dpdf','-bestfit');
close(gcf);